REM
REM    Dice - a virtual dice roller
REM    Copyright (C) Mateusz Viste 2010
REM
REM    This program is free software: you can redistribute it and/or modify
REM    it under the terms of the GNU General Public License as published by
REM    the Free Software Foundation, either version 3 of the License, or
REM    (at your option) any later version.
REM
REM    This program is distributed in the hope that it will be useful,
REM    but WITHOUT ANY WARRANTY; without even the implied warranty of
REM    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
REM    GNU General Public License for more details.
REM
REM    You should have received a copy of the GNU General Public License
REM    along with this program.  If not, see <http://www.gnu.org/licenses/>.
REM

CONST pVer = "1.0"
DIM SHARED AS INTEGER Scaling

#INCLUDE ONCE "loaddice.bi"    ' Load dice graphics into memory

DIM AS UBYTE RolledNumber, DiceRolls
DIM RollStartTime AS DOUBLE

Scaling = VAL(COMMAND(1))
IF (Scaling < 1) OR (Scaling > 4096) THEN Scaling = 20

#IFDEF __FB_WIN32__  ' Use the GDI driver on Windows instead of DirectX (for compatibility reasons)
  #INCLUDE ONCE "fbgfx.bi"
  SCREENCONTROL(fb.SET_DRIVER_NAME, "GDI")
#ENDIF

SCREENRES (11 * Scaling), (11 * Scaling), 8, 7  ' Init screen (palettized 8 bit depth with 7 video pages)
PALETTE 0, 255, 255, 255  ' load white color into palette
PALETTE 1, 0, 0, 0        ' load black color into palette
WINDOWTITLE("Dice v" + pVer)

LoadDice()
SLEEP 250, 1

DO
  RANDOMIZE TIMER, 3
  RollStartTime = TIMER
  FOR DiceRolls = 1 TO 80
    RolledNumber = (INT(RND * 6) + 1)
    SCREENSET 0, RolledNumber
    WHILE (TIMER - RollStartTime) < (DiceRolls * 0.050)    ' wait 50 ms between rolls
      SLEEP 1, 1  ' Release some CPU time whenever you can
    WEND
  NEXT DiceRolls
  SLEEP
LOOP UNTIL NOT (INKEY = CHR(13))  ' If pressed ENTER, do it again, exit otherwise

END
